% Demonstration of the VAD used in the paper.
% Last modified: 28th March, 2014
% Author: Paulo Esquef, e-mail: pesquef@lncc.br

clear all; close all; clc

% Loads a test signal
[x,fs]=wavread('test_signal_1');  % loads a speech signal sampled at 44.1 kHz 
%[x,fs]=wavread('test_signal_2');  % loads a speech signal sampled at 44.1 kHz 

p1=150;  % Minimum voice-inactivity duration in ms
p2=50;  % Minimum voice-activity duration in ms

tic
[vad,ind0,ind1]=vad_v3(x,fs,p1,p2);
toc

figure(1)
close all; plot(x); hold on; plot(vad,'r','linewidth',2); 
set(gcf,'position',[277 209 1000 742]);
set(gca,'fontsize',15)
xlabel('Time (samples)')
ylabel('Amplitude')
legend('Test Signal','VAD')
axis([1 length(x) -1 1.05])


%  Test with reduced sample rate: fsd=1200 Hz 

xds=resample(x,100,3675,20);
fsd=1200;
tic
[vad2,ind0,ind1]=vad_v3(xds,fsd,p1,p2);
toc

figure(2)
plot(xds); hold on; plot(vad2,'r','linewidth',2); 
set(gcf,'position',[277 209 1000 742]);
set(gca,'fontsize',15)
xlabel('Time (samples)')
ylabel('Amplitude')
legend('Test Signal','VAD')
axis([1 length(xds) -1 1.05])

% As can be seen, VAD can be more efficiently obtained at lower
% samples rates, without loss of quality. 